//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#include "stdafx.h"
#include "emule.h"
#include "PPgNotify.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

IMPLEMENT_DYNAMIC(CPPgNotify, CPropertyPage)
CPPgNotify::CPPgNotify()
	: CPropertyPage(CPPgNotify::IDD)
{
	LoadSettings();
	Localize();
}

CPPgNotify::~CPPgNotify()
{
}

void CPPgNotify::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_COMBO_TBN_DTIME, m_dtime); // DonGato
	DDX_Control(pDX, IDC_COMBO_TBN_FSIZE, m_fsize); // DonGato
}

BEGIN_MESSAGE_MAP(CPPgNotify, CPropertyPage)
	ON_BN_CLICKED(IDC_CB_TBN_USESOUND, OnBnClickedCbTbnUsesound)
	ON_BN_CLICKED(IDC_CB_TBN_ONLOG, OnBnClickedCbTbnOnlog)
	ON_BN_CLICKED(IDC_CB_TBN_ONCHAT, OnBnClickedCbTbnOnchat)
	ON_BN_CLICKED(IDC_CB_TBN_POP_ALWAYS, OnBnClickedCbTbnPopAlways)
	ON_BN_CLICKED(IDC_CB_TBN_ONDOWNLOADADD, OnBnClickedCbTbnOndownloadAdd)
	ON_BN_CLICKED(IDC_CB_TBN_ONDOWNLOAD, OnBnClickedCbTbnOndownload)
	ON_BN_CLICKED(IDC_CB_TBN_IMPORTANT, OnBnClickedCbTbnImportant)
	ON_BN_CLICKED(IDC_BTN_BROWSE_WAV, OnBnClickedBtnBrowseWav)
	ON_CBN_SELCHANGE(IDC_COMBO_TBN_DTIME, OnCbnSelchangeDtime)
	ON_CBN_SELCHANGE(IDC_COMBO_TBN_FSIZE, OnCbnSelchangeFsize)
	ON_EN_CHANGE(IDC_EDIT_TBN_WAVFILE, OnEnChangeEditTbnWavfile)
END_MESSAGE_MAP()

BOOL CPPgNotify::OnInitDialog()
{
	CPropertyPage::OnInitDialog();

	// DonGato
	m_dtime.SetItemData(m_dtime.AddString(_T("1")),1000);
	m_dtime.SetItemData(m_dtime.AddString(_T("2")),2000);
	m_dtime.SetItemData(m_dtime.AddString(_T("3")),3000);
	m_dtime.SetItemData(m_dtime.AddString(_T("4")),4000);
	m_dtime.SetItemData(m_dtime.AddString(_T("5")),5000);
	m_dtime.SetItemData(m_dtime.AddString(_T("6")),6000);
	m_dtime.SetItemData(m_dtime.AddString(_T("7")),7000);
	m_dtime.SetItemData(m_dtime.AddString(_T("8")),8000);
	m_dtime.SetItemData(m_dtime.AddString(_T("9")),9000);

	// DonGato
	m_fsize.SetItemData(m_fsize.AddString(_T("7")),70);
	m_fsize.SetItemData(m_fsize.AddString(_T("8")),80);
	m_fsize.SetItemData(m_fsize.AddString(_T("9")),90);
	m_fsize.SetItemData(m_fsize.AddString(_T("10")),100);

	LoadSettings();
	Localize();

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void CPPgNotify::LoadSettings(void)
{
	CEdit* editPtr;
	CButton* btnPTR;

	if(m_hWnd)
	{                   
		if (app_prefs->GetUseDownloadAddNotifier()) 
				CheckDlgButton(IDC_CB_TBN_ONDOWNLOADADD, BST_CHECKED);
		if (app_prefs->GetUseDownloadNotifier()) 
				CheckDlgButton(IDC_CB_TBN_ONDOWNLOAD, BST_CHECKED);
		if (app_prefs->GetUseChatNotifier())  
				CheckDlgButton(IDC_CB_TBN_ONCHAT, BST_CHECKED);
		if (app_prefs->GetUseSoundInNotifier())
				CheckDlgButton(IDC_CB_TBN_USESOUND, BST_CHECKED);
		if (app_prefs->GetUseLogNotifier())
				CheckDlgButton(IDC_CB_TBN_ONLOG, BST_CHECKED);
		if (app_prefs->GetNotifierPopsEveryChatMsg())
				CheckDlgButton(IDC_CB_TBN_POP_ALWAYS, BST_CHECKED);
		if (app_prefs->GetNotifierPopOnImportantError()) 
			CheckDlgButton(IDC_CB_TBN_IMPORTANT, BST_CHECKED);

		btnPTR = (CButton*) GetDlgItem(IDC_CB_TBN_POP_ALWAYS);
		btnPTR->EnableWindow(IsDlgButtonChecked(IDC_CB_TBN_ONCHAT));

		editPtr = (CEdit*) GetDlgItem(IDC_EDIT_TBN_WAVFILE);
		editPtr->SetWindowText(app_prefs->GetNotifierWavSoundPath());

		for(int i = 0; i != m_dtime.GetCount(); i++)
			if(m_dtime.GetItemData(i) == app_prefs->NotificationDisplayTime())
				m_dtime.SetCurSel(i);

		for(int i = 0; i != m_fsize.GetCount(); i++)
			if(m_fsize.GetItemData(i) == app_prefs->NotificationFontSize())
				m_fsize.SetCurSel(i);

		OnBnClickedCbTbnUsesound();
	}

	SetModified(FALSE);
}

BOOL CPPgNotify::OnApply() 
{
//	CSingleLock PrefLock(&(app_prefs->m_Pref_Mutex),TRUE); 

    if(m_bModified)
	{
	    CEdit* editPTR;
		CString buffer;
		app_prefs->SetUseDownloadAddNotifier(IsDlgButtonChecked(IDC_CB_TBN_ONDOWNLOADADD));
		app_prefs->SetUseDownloadNotifier(IsDlgButtonChecked(IDC_CB_TBN_ONDOWNLOAD));
	   	app_prefs->SetUseChatNotifier(IsDlgButtonChecked(IDC_CB_TBN_ONCHAT));
    	app_prefs->SetUseLogNotifier(IsDlgButtonChecked(IDC_CB_TBN_ONLOG));        
    	app_prefs->SetUseSoundInNotifier(IsDlgButtonChecked(IDC_CB_TBN_USESOUND));
    	app_prefs->SetNotifierPopsEveryChatMsg(IsDlgButtonChecked(IDC_CB_TBN_POP_ALWAYS));
		app_prefs->SetNotifierPopOnImportantError(IsDlgButtonChecked(IDC_CB_TBN_IMPORTANT));
	
    	editPTR = (CEdit*) GetDlgItem(IDC_EDIT_TBN_WAVFILE);
		editPTR->GetWindowText(buffer);
		app_prefs->SetNotifierWavSoundPath(buffer);
	
		if (m_dtime.GetCurSel() != CB_ERR){
			app_prefs->SetNotificationDisplayTime(m_dtime.GetItemData(m_dtime.GetCurSel()));
		}
		if (m_fsize.GetCurSel() != CB_ERR){
			app_prefs->SetNotificationFontSize(m_fsize.GetItemData(m_fsize.GetCurSel()));
		}
	
		((CemuleDlg*)AfxGetMainWnd())->m_wndTaskbarNotifier.SetTextFont(_T("Arial"),theApp.glob_prefs->NotificationFontSize(),TN_TEXT_NORMAL,TN_TEXT_UNDERLINE); // Popup porperties [DonGato]
	
		SetModified(FALSE);
	}

	return CPropertyPage::OnApply();
}

void CPPgNotify::Localize(void)
{
	if(m_hWnd){
		SetWindowText(GetResString(IDS_PW_EKDEV_OPTIONS));
		GetDlgItem(IDC_CB_TBN_USESOUND)->SetWindowText(GetResString(IDS_PW_TBN_USESOUND));
		GetDlgItem(IDC_BTN_BROWSE_WAV)->SetWindowText(GetResString(IDS_PW_BROWSE));
		GetDlgItem(IDC_CB_TBN_ONLOG)->SetWindowText(GetResString(IDS_PW_TBN_ONLOG));
		GetDlgItem(IDC_CB_TBN_ONCHAT)->SetWindowText(GetResString(IDS_PW_TBN_ONCHAT));
		GetDlgItem(IDC_CB_TBN_POP_ALWAYS)->SetWindowText(GetResString(IDS_PW_TBN_POP_ALWAYS));
		GetDlgItem(IDC_CB_TBN_ONDOWNLOADADD)->SetWindowText(GetResString(IDS_PW_TBN_ONDOWNLOADADD));
		GetDlgItem(IDC_CB_TBN_ONDOWNLOAD)->SetWindowText(GetResString(IDS_PW_TBN_ONDOWNLOAD));
		GetDlgItem(IDC_CB_TBN_IMPORTANT)->SetWindowText(GetResString(IDS_PS_TBN_IMPORTANT));

		GetDlgItem(IDC_TBN_OPTIONS)->SetWindowText(GetResString(IDS_PW_TBN_OPTIONS));
		GetDlgItem(IDC_TBN_PROPERTIES)->SetWindowText(GetResString(IDS_TBN_PROPERTIES));
		GetDlgItem(IDC_CB_TBN_DTIME)->SetWindowText(GetResString(IDS_CB_TBN_DTIME)); // DonGato
		GetDlgItem(IDC_CB_TBN_FSIZE)->SetWindowText(GetResString(IDS_CB_TBN_FSIZE)); // DonGato
		GetDlgItem(IDC_CB_TBN_SEC)->SetWindowText(GetResString(IDS_SECS)); // DonGato
	}
}

CString CPPgNotify::DialogBrowseFile(CString Filters, CString DefaultFileName)
{
        CFileDialog myFileDialog(true,NULL,LPCTSTR(DefaultFileName),
                OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, LPCTSTR(Filters));
        myFileDialog.DoModal();
        return myFileDialog.GetPathName();
}

void CPPgNotify::OnBnClickedCbTbnOnchat()
{
    CButton* btnPTR;
    btnPTR = (CButton*) GetDlgItem(IDC_CB_TBN_POP_ALWAYS);
    btnPTR->EnableWindow(IsDlgButtonChecked(IDC_CB_TBN_ONCHAT));	

	SetModified();
}

void CPPgNotify::OnBnClickedBtnBrowseWav()
{
//	CSingleLock PrefLock(&(app_prefs->m_Pref_Mutex),TRUE); 

    CEdit* editPTR;
	CString buffer;
    buffer = DialogBrowseFile(_T("File wav (*.wav)|*.wav||"));
    editPTR = (CEdit*) GetDlgItem(IDC_EDIT_TBN_WAVFILE);
    editPTR->SetWindowText(LPCTSTR(buffer));
	app_prefs->SetNotifierWavSoundPath(buffer);

	SetModified();
}

void CPPgNotify::OnBnClickedCbTbnUsesound()
{
	GetDlgItem(IDC_EDIT_TBN_WAVFILE)->EnableWindow(IsDlgButtonChecked(IDC_CB_TBN_USESOUND));
	GetDlgItem(IDC_BTN_BROWSE_WAV)->EnableWindow(IsDlgButtonChecked(IDC_CB_TBN_USESOUND));

	SetModified();
}
