// OpCode.h: interface for the COpCode class.
//
//////////////////////////////////////////////////////////////////////
#ifdef NEW_SOCKETS
#if !defined(AFX_OPCODE_H__E3263944_435F_44B4_A12E_EAA19AAE08AD__INCLUDED_)
#define AFX_OPCODE_H__E3263944_435F_44B4_A12E_EAA19AAE08AD__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

struct CTag {
	CString	m_strTagName;
	BYTE	m_nTagID;

	CString	m_strValue;
	DWORD	m_dwValue;
	bool	m_bIsString;
};

class CStream
{
public:
	virtual void Write(PCVOID, DWORD);
	virtual void Read(PVOID, DWORD);

	template <class T> void Write_T(const T& stObj) { Write(&stObj, sizeof(stObj)); }
	template <class T> void Read_T(T& stObj) { Read(&stObj, sizeof(stObj)); }

	void Write_T(const CString& strObj);
	void Read_T(CString& strObj);

	void Write_T(const CTag&);
	void Read_T(CTag&);
	void Read_Str(CString& strObj, USHORT nLen);

	void WriteTag(BYTE nTagID, const CString* pTagName, DWORD dwValue, const CString* pValue);

	struct CException {
		static void Throw() { CException stException; throw stException; }
	}; // self-explanable
};


class COpCode  
{
protected:
	virtual void Z_Read(CStream&) = NULL;
	virtual void Z_Write(CStream&) = NULL;
public:

	COpCode();
	virtual ~COpCode();

	bool Write(CStream&);
	virtual USHORT GetMsgID() const = NULL;

	static COpCode* Create(CStream&);
};

class COpCode_HELLO_TYPE : public COpCode {
protected:
	virtual void Z_Read(CStream&) = NULL;
	virtual void Z_Write(CStream&) = NULL;
public:
	BYTE	m_pHash[16];
	DWORD	m_dwClientID;
	USHORT	m_nPort;
	CString m_strNick;
	DWORD	m_dwVersion;
	DWORD	m_dwServerIp;
	USHORT	m_nServerPort;
};
/*
class COpCode_HELLO_TYPE : public COpCode {
public:
	BYTE	m_nHashSize; // always 16
	BYTE	m_nHash[16];
	DWORD	m_dwClientID;
	USHORT	m_nPort;

	DWORD	m_dwTagCount; // always 3
	CTag	m_tgUserNick;
	CTag	m_tgVersion;
	CTag	m_tgPort; // always the same as USHORT

	ULONG	m_nServerIp;
	USHORT	m_nServerPort;
};
*/

class COpCode_HELLO : public COpCode_HELLO_TYPE {
public:
	virtual USHORT GetMsgID() const;
};

class COpCode_HELLOANSWER : public COpCode_HELLO_TYPE {
public:
	virtual USHORT GetMsgID() const;
};


const BYTE CT_NAME		= 0x01;
const BYTE CT_VERSION	= 0x11;
const BYTE CT_PORT		= 0x0f;

#endif // !defined(AFX_OPCODE_H__E3263944_435F_44B4_A12E_EAA19AAE08AD__INCLUDED_)
#endif